> This page is for Developer.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.bigcommerce.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.bigcommerce.com/_mcp/server.

# Update Store Metafield

PUT https://api.bigcommerce.com/stores/{store_hash}/v3/store/metafields/{metafieldId}
Content-Type: application/json

Update a store `Metafield`.


Reference: https://docs.bigcommerce.com/developer/api-reference/rest/admin/management/store-information/v3/metafields/update-store-metafield

## Authentication

- `X-Auth-Token` header (required) — ### OAuth scopes | UI Name | Permission | Parameter | |:--------|:-----------|:----------| | Information & Settings | modify | `store_v2_information` | | Information & Settings | read-only | `store_v2_information_read_only` | ### Authentication header | Header | Argument | Description | |:-------|:---------|:------------| | `X-Auth-Token` | `access_token` | For more about API accounts that generate `access_token`s, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#api-accounts). | ### Further reading For example requests and more information about authenticating BigCommerce APIs, see [Authentication and Example Requests](/developer/docs/overview/api-fundamentals/api-accounts#x-auth-token-header-example-requests). For more about BigCommerce OAuth scopes, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#oauth-scopes). For a list of API status codes, see [API Status Codes](/developer/api-reference/rest/overview#rest-http-status-codes).

## Request

### Path parameters

- `metafieldId` (integer, required) — The ID of the `Metafield`.
- `store_hash` (string, required) — Permanent ID of the BigCommerce store.

### Headers

- `Accept` (string, optional, default: application/json) — The [MIME type](https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types) of the response body.

### Body (application/json)

This endpoint expects a MetafieldBase_Post_Put.

- `permission_set` (enum, required) — Determines the visibility and writeability of the field by other API consumers. | Value | Description | | :--- | :--- | | `app_only` | Private to the app that owns the field. | | `read` | Visible to other API consumers. | | `write` | Open for reading and writing by other API consumers. | | `read_and_sf_access` | Visible to other API consumers, including on the storefront. | | `write_and_sf_access` | Open for reading and writing by other API consumers, including on the storefront. |
  - Allowed values: `app_only`, `read`, `write`, `read_and_sf_access`, `write_and_sf_access`
- `namespace` (string, required) — Namespace for the metafield, for organizational purposes.
- `key` (string, required) — The name of the field, for example: `location_id`, `color`.
- `value` (string, required) — The value of the field, for example: `1`, `blue`.
- `description` (string, optional) — Description for the metafields.

## Response

### 200

A metafield and metadata.

- `data` (Metafield, optional) — Allows app partners to write custom data to various resources in the API.
- `meta` (metaCollection_open, optional) — Response metadata.

## Errors

### 404 Not Found Error

The resource was not found.

- `status` (integer, optional) — 404 HTTP status code.
- `title` (string, optional) — The error title describing the particular error.
- `type` (string, optional)

## Types

### Metafield

Allows app partners to write custom data to various resources in the API.

- `permission_set` (enum, required) — Determines the visibility and writeability of the field by other API consumers. | Value | Description | | :--- | :--- | | `app_only` | Private to the app that owns the field. | | `read` | Visible to other API consumers. | | `write` | Open for reading and writing by other API consumers. | | `read_and_sf_access` | Visible to other API consumers, including on the storefront. | | `write_and_sf_access` | Open for reading and writing by other API consumers, including on the storefront. |
  - Allowed values: `app_only`, `read`, `write`, `read_and_sf_access`, `write_and_sf_access`
- `date_created` (datetime, optional) — Date and time of the metafieldʼs creation.
- `date_modified` (datetime, optional) — Date and time when the metafield was last updated.
- `description` (string, optional) — Description for the metafields.
- `id` (string, optional) — The unique identifier for the metafield.
- `key` (string, optional) — The name of the field, for example: `location_id`, `color`.
- `namespace` (string, optional) — Namespace for the metafield, for organizational purposes.
- `owner_client_id` (string, optional) — Client ID for the metafieldʼs creator.
- `resource_id` (string, optional) — The unique identifier for the resource with which the metafield is associated.
- `resource_type` (enum, optional) — The type of resource with which the metafield is associated.
  - Allowed values: `brand`, `product`, `variant`, `category`, `cart`, `store`
- `value` (string, optional) — The value of the field, for example: `1`, `blue`.

### metaCollection_open

Response metadata.

## Examples

**Request**

```json
{
  "permission_set": "app_only",
  "namespace": "Sales Department",
  "key": "Staff Name",
  "value": "Ronaldo"
}
```

**Response**

```json
{
  "data": {
    "permission_set": "app_only",
    "date_created": "2022-06-16T18:39:00+00:00",
    "date_modified": "2022-06-16T18:39:00+00:00",
    "description": "order",
    "id": "string",
    "key": "Staff Name",
    "namespace": "Sales Department",
    "owner_client_id": "asdfasdfasdfasdfasdfasdfasdf",
    "resource_id": "0",
    "resource_type": "store",
    "value": "Ronaldo"
  },
  "meta": {}
}
```

**SDK Code**

```python
import requests

url = "https://api.bigcommerce.com/stores/store_hash/v3/store/metafields/1"

payload = {
    "permission_set": "app_only",
    "namespace": "Sales Department",
    "key": "Staff Name",
    "value": "Ronaldo"
}
headers = {
    "X-Auth-Token": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.bigcommerce.com/stores/store_hash/v3/store/metafields/1';
const options = {
  method: 'PUT',
  headers: {'X-Auth-Token': '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"permission_set":"app_only","namespace":"Sales Department","key":"Staff Name","value":"Ronaldo"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.bigcommerce.com/stores/store_hash/v3/store/metafields/1"

	payload := strings.NewReader("{\n  \"permission_set\": \"app_only\",\n  \"namespace\": \"Sales Department\",\n  \"key\": \"Staff Name\",\n  \"value\": \"Ronaldo\"\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("X-Auth-Token", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.bigcommerce.com/stores/store_hash/v3/store/metafields/1")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["X-Auth-Token"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"permission_set\": \"app_only\",\n  \"namespace\": \"Sales Department\",\n  \"key\": \"Staff Name\",\n  \"value\": \"Ronaldo\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://api.bigcommerce.com/stores/store_hash/v3/store/metafields/1")
  .header("X-Auth-Token", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"permission_set\": \"app_only\",\n  \"namespace\": \"Sales Department\",\n  \"key\": \"Staff Name\",\n  \"value\": \"Ronaldo\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://api.bigcommerce.com/stores/store_hash/v3/store/metafields/1', [
  'body' => '{
  "permission_set": "app_only",
  "namespace": "Sales Department",
  "key": "Staff Name",
  "value": "Ronaldo"
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'X-Auth-Token' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.bigcommerce.com/stores/store_hash/v3/store/metafields/1");
var request = new RestRequest(Method.PUT);
request.AddHeader("X-Auth-Token", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"permission_set\": \"app_only\",\n  \"namespace\": \"Sales Department\",\n  \"key\": \"Staff Name\",\n  \"value\": \"Ronaldo\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "X-Auth-Token": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "permission_set": "app_only",
  "namespace": "Sales Department",
  "key": "Staff Name",
  "value": "Ronaldo"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.bigcommerce.com/stores/store_hash/v3/store/metafields/1")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```